#!/usr/bin/env ruby
CiVersion = 'Gamma.6'
CiCode = 'WXIII'
#
# $Id: Ci.rb,v 1.98 2003/10/18 15:15:20 Yuukis Exp $
#
# Default configuration.

Root = "#{ENV['HOME']}/.ci/"				# cache files place
$KCODE = 'e'

#
# Default configuration (can overwrite user config).

scriptRoot = "#{ENV['HOME']}/opt/Ci/"		# loding scripts and others directory
boardSelect = 'left'						# 'right' or 'left'
favoriteBoards = []							# ex. ['unix', 'linux', 'tech']
httpCommand = 'mozilla -remote "openurl(%d)"'
											# which your web user agent. replace "%d" as URI.
defaultName = '̵̾'		# default name in follow up.
defaultMailto = 'sage'						# default mail address in follow up.
bbsMenuCheck = true							# true / false BBSMenuCheck at Starting C.i.
netUpCi = false								# get release information.
threadTabWidth = 6							# Thread Tab Width.
tabButtonType = 2							# Type of button(s) on tab.
											# 0 => No Buttons, 1 => close only, 2 => close and move.
# closeOnTab = true							# true / false Close button on tab.
bookmarkButtons = 0							# number of bookmark buttons under subjectFrame.
bookmarkBackground = [ 55000, 55000, 55000 ]# Bookmarked thread row's background color.
defaultWidth = 525							# Default window width.
defaultHeight = 450							# Default window height.
postBoxBorderWidth = 0						# PostBox Border width.
postBoxWidth = 250							# PostBox width.
boardSelectorBorderWidth = 0				# BoardSelector Border width.
boardSelectorWidth = 300					# Board Selector width.
getProxyAddr = nil							# Porxy Server for Get.
getProxyPort = nil
postProxyAddr = nil							# Proxy Server for Post.
postProxyPort = nil
migemoDict = ''								# Migemo dict place.
migemoDictCache = ''						# Migemo cache dict place.

#
#

require 'gtk'

Dir.mkdir(Root) unless File.exist?(Root)
BBSMenuURI = 'http://www.ff.iij4u.or.jp/~ch2/bbsmenu.html'
MonazillaUA = "Monazilla/1.00 (C.i./#{CiVersion})"

# Load UserConfig
if File.exist?("#{Root}ci.cfg")
	userConf = IO.readlines("#{Root}ci.cfg").join
	eval(userConf)
end


# set or overwrite configuration.
#  ȤꤢեθߴݤΤˡѤʤ
#  evalˤɤ߹ߤȹ碌ơ򸫤ѹ
#  # ʻ.......(^^;
#
$cfg = {}

$cfg['scriptRoot']= scriptRoot
$cfg['boardSelect']= boardSelect
$cfg['favoriteBoards']= favoriteBoards
$cfg['httpCommand']= httpCommand
$cfg['defaultName']= defaultName
$cfg['defaultMailto']= defaultMailto
$cfg['bbsMenuCheck']= bbsMenuCheck
$cfg['netUpCi']= netUpCi
$cfg['threadTabWidth']= threadTabWidth
$cfg['tabButtonType']= tabButtonType
#$cfg['closeOnTab']= closeOnTab
$cfg['bookmarkButtons']= bookmarkButtons
$cfg['bookmarkBackground']= bookmarkBackground
$cfg['defaultWidth']= defaultWidth
$cfg['defaultHeight']= defaultHeight
$cfg['postBoxBorderWidth'] = postBoxBorderWidth
$cfg['postBoxWidth'] = postBoxWidth
$cfg['boardSelectorBorderWidth']= boardSelectorBorderWidth
$cfg['boardSelectorWidth']= boardSelectorWidth
$cfg['getProxyAddr']= getProxyAddr
$cfg['getProxyPort']= getProxyPort
$cfg['postProxyAddr']= postProxyAddr
$cfg['postProxyPort']= postProxyPort
$cfg['migemoDict']= migemoDict
$cfg['migemoDictCache']= migemoDictCache

# Load gzip
#  Thank you for 11ܤ̵̾
p = ENV['PATH'].split(':')
p.each {|path|
	if File.executable?("#{path}/gzip")
		$cfg['gzip']= "#{path}/gzip"
		break
	end
}

if $cfg['gzip'] == nil
	puts "Can't find the gzip in \$PATH !!"
	exit
end

# Load migemo
#
$cfg['useMigemo']= true

if $cfg['migemoDict'] != ''
	[$cfg['migemoDict'], $cfg['migemoDictCache']].each {|x|
		unless File.exist?(x)
			puts "#{x}Ĥޤ$cfg['useMigemo']= false ǵưޤ"
			$cfg['useMigemo']= false
		end
	}
else
	$cfg['useMigemo']= false
end

if $cfg['useMigemo']
	begin
		require 'migemo'
		$cfg['useMigemo']= true
		$cfg['migemoDict']= MigemoStaticDict.new($cfg['migemoDict'])
		$cfg['migemoDictCache']= MigemoDictCache.new($cfg['migemoDictCache'])
	rescue LoadError
		$cfg['useMigemo']= false
	end
end


Thread::abort_on_exception = true
load "#{$cfg['scriptRoot']}util2ch.rb"
CiPixRoot = "#{$cfg['scriptRoot']}pixmap/"
Zcat = "#{$cfg['gzip']} -d"

Color_Base = Gdk::Color.new(0,0,0)
Color_DarkGreen = Gdk::Color.new(0,25700,0)
Color_DarkBlue = Gdk::Color.new(0,0,35723)
Color_Purple = Gdk::Color.new(32896,0,32896)
Color_Blue = Gdk::Color.new(0,0,65535)
Color_Bookmark = Gdk::Color.new($cfg['bookmarkBackground'][0],
	$cfg['bookmarkBackground'][1], $cfg['bookmarkBackground'][2])

RegexID = /^\d/
RegexFollow = /^(.*?)([>]{1,2}[\d-]+)(.*)/e
RegexFollowMany = /^(.*?)([>]{1,2}[\d-]+[-=,]\s?\d+)(.*)/e
RegexQuote = /^\s[>](?![>]?\d+).*/e
RegexUri = /^(.*?)([h|f]?t?tps?:[a-zA-Z0-9%&\?\/\;\:\@\&\=\+\$\,\-\_\.\!\~\*\'\\#]+)(.*)$/
Regex2chThread = /^(.*?)h?ttp:\/\/.+\.(2ch\.net|bbspink\.com)\/test\/read\.cgi\/(\S+)\/(\d+)(.*)$/

case ARGV[0]
when '-v'
	puts "C.i. - Compact Interface for 2ch. version #{CiVersion} (#{CiCode})"
	puts " Ruby: #{RUBY_VERSION} (#{RUBY_RELEASE_DATE})"
	puts " Gtk+: #{Gtk::VERSION[0]}.#{Gtk::VERSION[1]}.#{Gtk::VERSION[2]}"
	puts " Ruby/Gtk+: #{Gtk::BINDING_VERSION[0]}.#{Gtk::BINDING_VERSION[1]}#{Gtk::BINDING_VERSION[2]}"
	puts " PlatForm: #{RUBY_PLATFORM}"
	exit
when '-c'
	system("#{$cfg['scriptRoot']}chkclr.rb")
	exit
when '-g'
	$cfg['bbsMenuCheck']= true
end

class NodeData
	def initialize(uri)
		@uri = uri
	end

	def uri
		return(@uri)
	end
end

class Status
	def initialize
		@status = false
	end

	def toggleStatus
		if @status == true
			@status = false
		else
			@status = true
		end
		return(@status)
	end

	def active?
		@status
	end
end

class FollowPop < Gtk::Menu
	def initialize(str)
		super()
		fs = Gtk::MenuItem.new(str)
		fs.child.set_justify(Gtk::JUSTIFY_LEFT)
		fs.signal_connect('button_press_event'){
			popdown
		}

		append Gtk::MenuItem.new
		append fs
		append Gtk::MenuItem.new

		show_all
	end
end

class RightMenu < Gtk::Menu
	def initialize(title)
		super()
		@title = Gtk::MenuItem.new(title)
		self.append @title
		self.append Gtk::MenuItem.new
		@bookmark = Gtk::MenuItem.new('add Bookmark')
		self.append @bookmark
		@abone = Gtk::MenuItem.new('Abone this Thread')
		self.append @abone

		self.show_all
	end

	def title
		@title
	end

	def bookmark
		@bookmark
	end

	def abone
		@abone
	end
end

class Windmill < Gtk::Button  #=> Thread Manager.
	def initialize
		@ab = Pix.getPixmap('about')
		@wind = []
		['load', 'load+1', 'load+2', 'load+1',
		 'load', 'load-1', 'load-2', 'load-1'].each {|i| @wind << Pix.getPixmap(i)}
		super()
		add @ab
		set_usize(22, 16)
		#@wind = ['\\', '|', '/', '--']
		@thr = Thread.fork { Thread.exit }
		@q = []
	end

	def start(purpose = '')
		if @q.include?(purpose)
			return(false) #=> already.
		else
			if @q.empty?
				@thr = Thread.fork {
					show_all
					while true
						@wind.each {|w| remove child; add(w).show_all ; sleep 0.5 }
					end
				}
			end
			@q << purpose
			return(true) #=> OK.
		end
	end

	def stop(purpose = '')
		@q.delete(purpose)
		if @q.empty?
			@thr.kill if @thr.alive?
			remove child
			add @ab
		end
	end

	def kill
		@thr.kill if @thr.alive?
			remove child
			add @ab
		@q.clear
	end

	def q
		return(@q)
	end
end

module CiUtil
	def setTooltip(widget, text)
		tooltip = Gtk::Tooltips.new
		tooltip.set_tip(widget, text, nil)
	end

	def trunc(str)  # From goRua. Thanks.
		if  /^(.{1,#{$cfg['threadTabWidth']}}).*$/ =~ str
			return $1
		else
			return str
		end
	end
end

class CiPix
    def initialize(w)
		@w = w
		@close = [
			"10 7 2 1",
			"  c black",
			".       c None s None",
			".  ....  .",
			"..  ..  ..",
			"...    ...",
			"....  ....",
			"...    ...",
			"..  ..  ..",
			".  ....  ."
		]
		@next = [
			"5 7 2 1",
			"  c black",
			".       c None s None",
			"  ...",
			".  ..",
			"..  .",
			"...  ",
			"..  .",
			".  ..",
			"  ..."
		]
		@prev = [
			"7 7 2 1",
			"  c black",
			".       c None s None",
			"....  .",
			"...  ..",
			"..  ...",
			".  ....",
			"..  ...",
			"...  ..",
			"....  ."
		]
	end

	def getPixmap(name)
		if name == 'close'
			pix, mask = Gdk::Pixmap.create_from_xpm_d(@w.window, nil, @close)
		elsif name == 'next'
			pix, mask = Gdk::Pixmap.create_from_xpm_d(@w.window, nil, @next)
		elsif name == 'prev'
			pix, mask = Gdk::Pixmap.create_from_xpm_d(@w.window, nil, @prev)
		else
			pix, mask = Gdk::Pixmap.create_from_xpm(@w.window, nil,
				"#{CiPixRoot}#{name}.xpm")
		end
		return(Gtk::Pixmap.new(pix, mask))
	end
end

class CiPost < Gtk::VBox
	include PostMessage2ch
	include CiUtil
	include Filter

	def initialize(board, dat, title)
		@board = board
		@dat = dat
		@title = title
		@getThread = Thread.fork { Thread.exit }
		@update = false

		super()
		
		nameLabel = Gtk::Label.new(' Name ')
		mailLabel = Gtk::Label.new(' Mailto ')

		@nameEntry = Gtk::Combo.new
		@mailEntry = Gtk::Combo.new

		nBox = Gtk::HBox.new
		nBox.pack_start nameLabel, false
		nBox.pack_start @nameEntry

		mBox = Gtk::HBox.new
		mBox.pack_start mailLabel, false
		mBox.pack_start @mailEntry

		entriesBox = Gtk::HBox.new
		entriesBox.pack_start nBox
		entriesBox.pack_start mBox

		@cancelButton = Gtk::Button.new.add Pix.getPixmap('cancel')
		setTooltip(@cancelButton, 'Close this window')
			# cancelButton.signal_connect('clicked') { hide }
		@quoteButton = Gtk::Button.new.add Pix.getPixmap('quote')
		setTooltip(@quoteButton, 'Quote from Selection.')
		postButton = Gtk::Button.new.add Pix.getPixmap('followup')
		setTooltip(postButton, 'Post message')
			postButton.signal_connect('clicked') {
				@status.set_text('Posting Now.....')
				@getThread = Thread.fork {
					wrote, body = postMessage($bbsHash[@board], @board, @dat,
						@nameEntry.entry.get_text, @mailEntry.entry.get_text,
						@text.get_chars(0, @text.get_length))
					if wrote
						postInfoWrite(@nameEntry.entry.get_text, @mailEntry.entry.get_text,
							"#{Root}#{@board}/cache/#{@dat}.post")
						@update = true
						@cancelButton.clicked
						# destroy
					else
						@status.set_text(body)
					end
				}
			}
		aaButton = Gtk::MenuBar.new
		setTooltip(aaButton, 'Insert the Ascii Art')
			aaMenuRoot = Gtk::MenuItem.new.add Gtk::Label.new('A.A.') # Pix.getPixmap('aa')
			aaButton.append aaMenuRoot
			aaMenu = Gtk::Menu.new
			aaMenuRoot.set_submenu aaMenu
			aaList = getAAList
			aaList.each {|aa|
				label = Gtk::MenuItem.new(aa.chomp)
				aaMenu.append label
				label.signal_connect('activate') {
					@text.insert_text(aa.chomp, @text.position)
				}
			}
		filterButton = Gtk::MenuBar.new
		setTooltip(filterButton, 'Filtering the message.')
			fiMenuRoot = Gtk::MenuItem.new.add Gtk::Label.new('Filtering')
			filterButton.append fiMenuRoot
			fiMenu = Gtk::Menu.new
			fiMenuRoot.set_submenu fiMenu
			fiList = getFilterList
			fiList.each {|fi|
				label = Gtk::MenuItem.new(fi)
				fiMenu.append label
				label.signal_connect('activate') {
					str = @text.get_chars(0, @text.get_length)
					@text.delete_text(0, @text.get_length)
					@text.insert_text(filtering(fi, str), 0)
				}
			}

		blank = Gtk::Label.new('')
		@titleLabel = Gtk::Label.new('')

		sw = Gtk::ScrolledWindow.new
		sw.set_policy(Gtk::POLICY_NEVER, Gtk::POLICY_ALWAYS)
		@text = Gtk::Text.new.set_editable(true)
		@text.signal_connect('key_press_event') {|w, e|
			if e.state == Gdk::CONTROL_MASK
				case e.keyval
				when Gdk::GDK_Return
					postButton.clicked
				when Gdk::GDK_c
					@cancelButton.clicked
				when Gdk::GDK_t
					aaMenu.popup(nil, nil, nil, 1, e.time)
				when Gdk::GDK_f
					fiMenu.popup(nil, nil, nil, 1, e.time)
				end
			end
		}
		sw.add @text

		buttonBox = Gtk::HBox.new
		buttonBox.pack_start @titleLabel, false
		buttonBox.pack_start blank, true
		buttonBox.pack_start postButton, false
		buttonBox.pack_start @cancelButton, false
		buttonBox.pack_start @quoteButton, false
		buttonBox.pack_start aaButton, false
		buttonBox.pack_start filterButton, false

		@status = Gtk::Label.new('')

		self.pack_start buttonBox, false
		self.pack_start entriesBox, false
		self.pack_start sw, true
		self.pack_start @status, false
	end

	def cancel
		return(@cancelButton)
	end

	def quote
		return(@quoteButton)
	end

	def post?(p = false)
		@update = false if p
		return(@update)
	end

	def clear
		@text.delete_text(0, @text.get_length)
		@nameEntry.entry.set_text('')
		@mailEntry.entry.set_text('')
		@titleLabel.set_text('')
		@status.set_text('')
	end

	def clear?
		if @titleLabel.get_text == ''
			return(true)
		else
			return(false)
		end
	end

	def text
		@text
	end

	def show_all(str = false, num = false)
		insertReply(str, num)
		name, mailto = postInfoRead("#{Root}#{@board}/cache/#{@dat}.post")
		@nameEntry.entry.set_text(name[0])
		@nameEntry.set_popdown_strings(name)
		@mailEntry.entry.set_text(mailto[0])
		@mailEntry.set_popdown_strings(mailto)
		@titleLabel.set_text(' Re: '.concat(@title))
		super()
		# self.set_focus(@text)
	end

	def insertReply(str, num)
		if str
			@text.insert nil, nil, nil, '>>'.concat(num.to_s.concat("\n"))
			str.each {|line| @text.insert nil, nil, nil, '> '.concat(line.sub(/^\s/, ''))}
			@text.insert nil, nil, nil, "\n"
			@text.position= @text.get_length
		end
	end
end

class BoardSelector < Gtk::ScrolledWindow
	include BBSMenu

	def initialize
		@boardTree = Gtk::CTree.new(["Board Name"], 0)
		@boardTree.set_line_style(Gtk::CTree::LINES_DOTTED)
		@boardTree.set_line_style(Gtk::CTree::LINES_DOTTED)
		@boardTree.set_selection_mode(Gtk::SELECTION_BROWSE)
		@row = 0

		@vadj = Gtk::Adjustment.new(0, 0, 0, 0, 0, 0)
		super(nil, @vadj)
		set_policy(Gtk::POLICY_NEVER, Gtk::POLICY_ALWAYS)

		@boardTree.signal_connect('select_row') {|w, r, c, e| @row = r }
		@boardTree.signal_connect('key_press_event') {|w, e|
			i = @vadj.upper / @boardTree.rows  # AdjustmentʻCList1Ԥι⤵
			x = 0
			case e.keyval
			when Gdk::GDK_j
				x = @row + 1  # @rowϾselect_row signalǼ
				@boardTree.select_row(x, 0)
				if x > (@vadj.value + @vadj.page_size + i) / i - 1.8  # MagicNumber. XD
					tmpVadj = @vadj.value + i
					if tmpVadj + @vadj.page_size < @vadj.upper
						@vadj.set_value(tmpVadj)
					else
						@vadj.set_value(@vadj.upper - @vadj.page_size)
					end
				end
			when Gdk::GDK_k
				x = @row - 1  # @rowϾselect_row signalǼ
				@boardTree.select_row(x, 0)
				if x < (@vadj.value - i) / i + 0.8  # MagicNumber. XD
					tmpVadj = @vadj.value - @vadj.upper / @boardTree.rows
					if tmpVadj + @vadj.page_size > @vadj.lower
						@vadj.set_value(tmpVadj)
					else
						@vadj.set_value(@vadj.lower)
					end
				end
			when Gdk::GDK_l
				node = ''
				@boardTree.each_selection {|n| node = n }
				@boardTree.toggle_expansion(node) unless @boardTree.get_node_info(node)[6]
			when Gdk::GDK_g
				@boardTree.select_row(0, 0)
				lower
			when Gdk::GDK_G
				@boardTree.select_row(@boardTree.rows - 1, 0)
				upper
			end
		}

		insert
		add @boardTree
	end

	def update
		getBBSMenu
		@boardTree.freeze
		@boardTree.clear
		@boardTree.thaw
		insert
	end

	def insert
		@boardTree.freeze
		root = @boardTree.insert_node(nil, nil, ["The 2ch Boards"], 1,
			nil, nil, nil, nil, false, true)
		nodes = parseBBSMenu
		nodes.each {|info|
			if info[1] == 'C-'
				@semiRoot = @boardTree.insert_node(root, nil, [info[0]], 1,
					nil, nil, nil, nil, false, false)
			else
				node = @boardTree.insert_node(@semiRoot, nil, [info[0]], 1,
					nil, nil, nil, nil, true, false)
				@boardTree.node_set_row_data(node, NodeData.new(info[1]))
			end
		}
		@boardTree.thaw
	end

	def widget
		@boardTree
	end

	def upper
		@vadj.set_value(@vadj.upper - @vadj.page_size)
	end

	def lower
		@vadj.set_value(@vadj.lower)
	end
end

class SubjectFrame < Gtk::ScrolledWindow
	def initialize(top, board)  # subjectFrame
		@top = top
		@updateFilter = Status.new
		@board = board
		@board = 'unix' if @board == ''
		@past = board
		@vadj = Gtk::Adjustment.new(0, 0, 0, 0, 0, 0)
		@pop = false
		@freeze = false

		super(nil, @vadj)
		self.set_policy(Gtk::POLICY_NEVER, Gtk::POLICY_ALWAYS)
		@subjects = Gtk::CList.new(['', 'S', 'C', '', 'F', 'C', ' subject ']).set_usize(1,1)
		(0..5).each {|x|
			@subjects.set_column_justification(x, Gtk::JUSTIFY_RIGHT)
			@subjects.set_column_auto_resize(x, true)
		}
		@subjects.set_column_justification(6, Gtk::JUSTIFY_LEFT)
		@subjects.set_column_auto_resize(6, true)
		@subjects.set_column_min_width(4, 30)
		@subjects.set_column_min_width(5, 30)
		@subjects.set_selection_mode(Gtk::SELECTION_BROWSE)

		@bbsBoard = BBSBoard.new(@board)
		@threadHash = {}

		@subjects.signal_connect('key_press_event') {|w, e|
			i = @vadj.upper / @subjects.rows  # AdjustmentʻCList1Ԥι⤵
			x = 0
			case e.keyval
			when Gdk::GDK_j
				@subjects.each_selection {|row| x = row + 1 }
				@subjects.select_row(x, 0)
				if x > (@vadj.value + @vadj.page_size + i) / i - 1.8  # MagicNumber. XD
					tmpVadj = @vadj.value + i
					if tmpVadj + @vadj.page_size < @vadj.upper
						@vadj.set_value(tmpVadj)
					else
						@vadj.set_value(@vadj.upper - @vadj.page_size)
					end
				end
			when Gdk::GDK_k
				@subjects.each_selection {|row| x = row - 1 }
				@subjects.select_row(x, 0)
				if x < (@vadj.value - i) / i + 0.8  # MagicNumber. XD
					tmpVadj = @vadj.value - @vadj.upper / @subjects.rows
					if tmpVadj + @vadj.page_size > @vadj.lower
						@vadj.set_value(tmpVadj)
					else
						@vadj.set_value(@vadj.lower)
					end
				end
			when Gdk::GDK_g
				@subjects.select_row(0, 0)
				lower
			when Gdk::GDK_G
				@subjects.select_row(@subjects.rows - 1, 0)
				upper
			when Gdk::GDK_a
				r = 0
				@subjects.each_selection {|row| r = row }
				if @bbsBoard.bookmark?(@threadHash[@subjects.get_text(r, 0)])
					@bbsBoard.deleteBookmark(@threadHash[@subjects.get_text(r, 0)])
				else
					@bbsBoard.addBookmark(@threadHash[@subjects.get_text(r, 0)])
				end
				coloring
			when Gdk::GDK_d  # ܡ¨˥ȿǤ٤ʤ
				r = 0
				@subjects.each_selection {|row| r = row }
				@bbsBoard.addUserAbone(@threadHash[@subjects.get_text(r, 0)], @subjects.get_text(r, 6))
			end
		}

		@subjects.signal_connect('select_row') {|w, r, c, e|
			if e == nil
			elsif c == 0
				@pop = true
				menu = RightMenu.new(@subjects.get_text(r, 6))
				@bbsBoard.updateBookmark
				if @bbsBoard.bookmark?(@threadHash[@subjects.get_text(r, 0)])
					menu.bookmark.child.set_text('Delete Bookmark')
				else
					menu.bookmark.child.set_text('Add Bookmark')
				end
				menu.title.signal_connect('activate') {
					menu.popdown
					menu.destroy
					@top.set_focus(@subjects)
				}
				menu.bookmark.signal_connect('activate') {
					if @bbsBoard.bookmark?(@threadHash[@subjects.get_text(r, 0)])
						@bbsBoard.deleteBookmark(@threadHash[@subjects.get_text(r, 0)])
					else
						@bbsBoard.addBookmark(@threadHash[@subjects.get_text(r, 0)])
					end
					coloring
					menu.popdown
					menu.destroy
					@top.set_focus(@subjects)
				}
				menu.abone.signal_connect('activate') {
					@bbsBoard.addUserAbone(@threadHash[@subjects.get_text(r, 0)],
						@subjects.get_text(r, 6))
					menu.popdown
					menu.destroy
					@top.set_focus(@subjects)
				}
				menu.popup(nil, nil, nil, e.button, e.time)
			end
		}

		@subjects.signal_connect('click_column') {|w, c|
			case c
			when 1
				check
			# else
			# 	@subjects.sort_column= c
			# 	@subjects.sort
			end
		}

		h = @bbsBoard.getSubjects
		@subjects.freeze
		@threadHash.clear
		n = 0
		h.each {|th|
			n += 1
			@subjects.append([n.to_s, th[0], th[1], th[2], th[4], th[5], th[6].chomp])
			@threadHash[n.to_s]= th[3]
		}
		coloring
		@subjects.thaw

		self.add @subjects
		self
	end

	def switch(board)
		@past = @board
		@board = board
		@bbsBoard = BBSBoard.new(board)
	end

	def update(get = true, search = false, bookmark = false)
		return(false) if @freeze
		@updateFilter.toggleStatus if @updateFilter.active?
		if search
			a = @bbsBoard.getSubjects(false, search)
		elsif bookmark
			a = @bbsBoard.getSubjects(false, false, false, true)
		else
			a = @bbsBoard.getSubjects(get)
		end
		@subjects.clear
		@subjects.freeze
		@threadHash.clear
		n = 0
		a.each {|th|
			n += 1
			@subjects.append([n.to_s, th[0], th[1], th[2], th[4], th[5], th[6].chomp])
			@threadHash[n.to_s]= th[3]
		}
		coloring
		@subjects.thaw
	end

	def rollback
		@bbsBoard.rollback
		#@subjects.unselect_all
	end

	def check # Updates Check.
		@subjects.clear
		if @updateFilter.toggleStatus
			h = @bbsBoard.getSubjects(false, false, true)
		else
			h = @bbsBoard.getSubjects(false, false, false)
		end
		@subjects.freeze
		@threadHash.clear
		n = 0
		h.each {|th|
		n += 1
			@subjects.append([n.to_s, th[0], th[1], th[2], th[4], th[5], th[6].chomp])
			@threadHash[n.to_s]= th[3]
		}
		coloring
		@subjects.thaw
	end

	def cached(row)
		@subjects.set_text(row, 2, 'C')
		@subjects.set_text(row, 3, '=')
		@subjects.set_text(row, 5, @subjects.get_text(row, 4))

		#=> subject.txtʤĤ塢downloadĤΥ褦Ȥ
		begin
			@bbsBoard.cachedThreadSave(@threadHash[@subjects.get_text(row, 0)], @board)
		rescue
			@bbsBoard.cachedThreadSave(@threadHash[@subjects.get_text(row, 0)], @past)
		end
	end

	def coloring
		r = 0
		@subjects.each_selection {|row| r = row}
		n = []
		(0..6).each {|i| n << @subjects.get_text(r, i)}

		@subjects.freeze
		@subjects.insert(r+1, n)
		@subjects.remove_row(r)
		@threadHash.each {|n, d|
			@subjects.set_background(n.to_i-1, Color_Bookmark) if @bbsBoard.bookmark?(d)
		}
		@subjects.thaw
	end

	def board
		return(@board)
	end

	def past
		return(@past)
	end

	def widget
		return(@subjects)
	end

	def type
		return('board')
	end

	def hash
		return(@threadHash)
	end

	def upper  # ƤӽФ / 󥹥ѿɬפ ? ׺ƹ͡
		@vadj.set_value(@vadj.upper - @vadj.page_size)
	end

	def lower
		@vadj.set_value(@vadj.lower)
	end

	def pop?
		if @pop
			@pop = false
			return(true)
		else
			return(false)
		end
	end

	def freeze  # ad hoc Ci¦н褹٤
		@freeze = true
	end

	def thaw
		@freeze = false
	end
end

class TextFrame < Gtk::VPaned
	include CiUtil

	def initialize(board, dat, url, top)
		@textframe = Gtk::HBox.new
		@id = {'board' => board, 'dat' => dat, 'url' => url }
		@bbsThread = BBSThread.new(board, dat)
		@top = top
		@vadj = Gtk::Adjustment.new(0, 0, 0, 0, 0, 0)
		vsb = Gtk::VScrollbar.new(@vadj)
		@text = Gtk::Text.new(nil, @vadj)
		@text.signal_connect('key_press_event'){|w, e|  # From goRua. Thanks.
			case e.keyval
			when Gdk::GDK_e
				@post.quote.clicked
			when Gdk::GDK_space
				tmp_vadj = @vadj.value + @vadj.page_size/1.1
				@vadj.set_value(tmp_vadj)
			when Gdk::GDK_BackSpace
				tmp_vadj = @vadj.value - @vadj.page_size/1.1
				@vadj.set_value(tmp_vadj)
			when Gdk::GDK_j
				tmp_vadj = @vadj.value + @vadj.page_size/10
				@vadj.set_value(tmp_vadj)
			when Gdk::GDK_k
				tmp_vadj = @vadj.value - @vadj.page_size/10
				@vadj.set_value(tmp_vadj)
			when Gdk::GDK_g
				@vadj.set_value(0)
			when Gdk::GDK_G
				@vadj.set_value(999999999)
			end
		}

		@text.signal_connect('button_press_event') {|w, e|
			case e.button
			when 5
				tmp_vadj = @vadj.value + @vadj.page_size/4
				@vadj.set_value(tmp_vadj)
			when 4
				tmp_vadj = @vadj.value - @vadj.page_size/4
				@vadj.set_value(tmp_vadj)
			when 3
				if has_selection?
					target = getSelection
					target.gsub!(/[>]*/, '').strip!
					case target
					when /^[\d-]+/e
						target = NKF.nkf('-Z', target)
						fpop = FollowPop.new(@bbsThread.getFollowUp(target.to_i))
						fpop.popup(nil, nil, nil, e.button, e.time)
					when Regex2chThread
						b = $3 ; d = $4
						b.sub(/(.+?)\/(\d+)/) { b = $1 ; d = $2 } if b =~ /\//
						r = @bbsThread.getStart(b, d+'.dat')
						if r
							fpop = FollowPop.new(r)
							fpop.popup(nil, nil, nil, e.button, e.time)
						end
					end
				end
			end
		}

		@textframe.pack_start @text
		@textframe.pack_start vsb, false

		get

		@post = CiPost.new(@id['board'], @id['dat'], @id['title'])

		@post.cancel.signal_connect('clicked') {
			postClose
			@top.set_focus(@text)
			if @post.post?
				update
				# adjust(999999999)
				@post.post?(true)
			end
		}

		@post.quote.signal_connect('clicked') {
			target, num = getSelection(true)
			@post.insertReply(target, num)
		}

		super()
		set_usize(1, 1)
		#signal_connect('size_allocate'){ p 'allocate ' }
		#signal_connect('size_request'){ p 'request ' }
		self.add1(@textframe)
		self.add2(@post)
		self.set_gutter_size(0)
		self.set_handle_size(0)
		self
	end

	def post
		@post
	end

	def get
		th, title = @bbsThread.getThread
		th = DownLoadFailed.sub(/url/, @id['url']) if th == false
		@id['title']= title.dat2txt!
		@text.freeze
		insertThread(th)
		@text.thaw
	end

	def update
		@bbsThread.getThread
		th = @bbsThread.getFollowUpCache(getResNum+'-')
		@text.freeze
		insertThread(th)
		@text.thaw
	end

	def reget
		@bbsThread.rmCache
		update
	end

	def getid
		return(@id)
	end

	def getResNum
		n = ''
		@text.get_chars(0, @text.get_length).each {|x| n = x if x =~ RegexID }
		n.sub!(/:.*/, '').chomp!
	end

	def type
		return('thread')
	end

	def widget
		return(@text)
	end

	def adjust(value = false)
		value = getVadjInfo unless value
		@vadj.set_value(value)
	end

	def has_selection?
		@text.has_selection?
	end

	def getSelection(getnum = false)
		startSelection = @text.selection_start_pos
		endSelection = @text.selection_end_pos
		if startSelection > endSelection
			tmp = startSelection ; startSelection = endSelection ; endSelection = tmp
		end
		target = @text.get_chars(startSelection, endSelection).chomp
		if getnum
			num = ''
			tmptext = @text.get_chars(0, startSelection)
			tmptext.split("\n").reverse_each {|line|
				if line =~ /^(\d+):/
					num = $1
					break
				end
			}
			return([target, num])
		else
			return(target)
		end
	end

	def label
		case $cfg['tabButtonType']
		when 0
			label = Gtk::Label.new("#{trunc(@id['title'])}")  # ܥ󤬤ʤẸ
			label.show_all
		when 1
			label = Gtk::Label.new("#{trunc(@id['title'])} ")
			@close = Gtk::Button.new.add Pix.getPixmap('close')
			box = Gtk::HBox.new
			box.pack_start label
			box.pack_start @close
			box.show_all
		else
			label = Gtk::Label.new("#{trunc(@id['title'])} ")
			@close = Gtk::Button.new.add Pix.getPixmap('close')
			@next = Gtk::Button.new.add Pix.getPixmap('next')
			@prev = Gtk::Button.new.add Pix.getPixmap('prev')
			box = Gtk::HBox.new
			box.pack_start label
			box.pack_start @prev
			box.pack_start @close
			box.pack_start @next
			box.show_all
		end
	end

	def labelButton
		@close
	end

	def labelButtonNext
		@next
	end

	def labelButtonPrev
		@prev
	end

	def setVadjInfo
		fh = open("#{Root}#{@id['board']}/cache/#{@id['dat']}.info", 'w')
		fh.write @vadj.value.to_s
		fh.close
	end

	def getVadjInfo
		if File.exist?("#{Root}#{@id['board']}/cache/#{@id['dat']}.info")
			fh = open("#{Root}#{@id['board']}/cache/#{@id['dat']}.info")
			value = fh.read
			fh.close
			return(value.to_f)
		else
			return(0)
		end
	end

	def vadjInfo?
		File.exist?("#{Root}#{@id['board']}/cache/#{@id['dat']}.info")
	end

	def postOpen
		if has_selection?
			target, num = getSelection(true)
			@post.show_all(target, num)
		else
			@post.show_all
		end
		self.set_gutter_size($cfg['postBoxBorderWidth']+2)
		self.set_handle_size($cfg['postBoxBorderWidth'])
		self.set_position($cfg['defaultHeight']-$cfg['postBoxWidth'])
	end

	def postClose
		self.set_gutter_size(0)
		self.set_handle_size(0)
		self.set_position(5000)
		@post.clear
		# @top.set_focus(@text)
	end

	def open?
		if @post.clear?
			return(false)
		else
			return(true)
		end
	end

	def find(word)
		if @text.selection_start_pos == @text.selection_end_pos
			pos = 0
		else
			pos = @text.position + 2
		end
		str = @text.get_chars(0, @text.get_length)
		result = str.jindex(word, pos)

		if result
			@text.set_position(result)
			@text.select_region(result, result + word.jlength)
		end
	end

	def increment(word)
		return if word == ''
		pos = 0
		str = @text.get_chars(0, @text.get_length)
		migemo = Migemo.new($cfg['migemoDict'], word)
		migemo.dict_cache = $cfg['migemoDictCache']
		if str =~ eval("/#{migemo.regex}/")
			x = $&
			result = str.jindex(x, pos)
			@text.set_position(result)
			@text.select_region(result, result + x.jlength)
		end
	end

	def addBookmark
		@bbsThread.addBookmark
	end

	def deleteBookmark
		@bbsThread.deleteBookmark
	end

	def bookmark?
		@bbsThread.bookmark?
	end

	def abone?
		@bbsThread.abone?
	end

	def addUserAbone
		@bbsThread.addUserAbone(@id['title'])
	end

	def insertThread(stream)
		stream.each {|line|  # from goRua. Thanks.
			line.chomp!
			baseColor = Color_Base
			baseColor = Color_Purple if line =~ RegexQuote
			while true
				case line
				when RegexID  # إå
					line.gsub!(/<\/b>/, '')
					line.gsub!(/<b>/, '')
					@text.insert nil, Color_DarkGreen, nil, line 
					break
				when RegexFollowMany  # FollowUpMany
					@text.insert nil, baseColor, nil, $1
					@text.insert nil, Color_DarkBlue, nil, $2
					line = $3
				when RegexFollow  # FollowUp
					@text.insert nil, baseColor, nil, $1
					@text.insert nil, Color_DarkBlue, nil, $2
					line = $3
				when RegexUri  # URL
					@text.insert nil, baseColor, nil, $1
					@text.insert nil, Color_Blue, nil, $2
					line = $3
				else
					@text.insert nil, baseColor, nil, line
					break
				end
			end
			@text.insert nil, baseColor, nil, "\n"
		}
	end
end

class About < Gtk::Window
	def initialize
		super()

		pFrame = Gtk::Frame.new
		pFrame.add Pix.getPixmap('logo')

		vStr =  "Compact Interface for 2ch.\n"
		vStr << "Version #{CiVersion} (#{CiCode})\n"
		vStr << "(C)2003 H.Miyamoto (aka \"Yuukis\")\n\n"
		vStr << "Powered by\n"
		vStr << "   Ruby #{RUBY_VERSION} (#{RUBY_RELEASE_DATE})\n"
		vStr << "   Gtk+ #{Gtk::VERSION[0]}.#{Gtk::VERSION[1]}.#{Gtk::VERSION[2]}\n"
		vStr << "   Ruby/Gtk+ #{Gtk::BINDING_VERSION[0]}.#{Gtk::BINDING_VERSION[1]}#{Gtk::BINDING_VERSION[2]}\n\n"
		vStr << "Send mail <Ys@PixyGarden.net> for contact.\n"
		vStr << "Visit http://wids.net/lab/Ci.html for updates.\n"
		vLabel = Gtk::Label.new(vStr).set_justify(Gtk::JUSTIFY_LEFT)

		close = Gtk::Button.new("\s"*5 + "OK" + "\s"*5)
		close.signal_connect('clicked') { hide }
		bBox = Gtk::HBox.new
		bBox.pack_start Gtk::Label.new('')
		bBox.pack_start close, false

		xBox = Gtk::VBox.new
		xBox.pack_start vLabel
		xBox.pack_start bBox, false

		vBox = Gtk::HBox.new
		vBox.pack_start Gtk::Label.new("\s"*25)
		vBox.pack_start xBox, false

		box = Gtk::VBox.new(false, 10)
		box.border_width = 8
		box.pack_start Pix.getPixmap('logo')
		box.pack_start vBox
		add box
		set_title('About C.i.')
		set_focus(close)
		signal_connect('delete_event') { hide }
		self
	end
end

class ConfigPop < Gtk::Menu
	def initialize
		super()
		@updateBBSMenu = Gtk::MenuItem.new('Update BBS menu.')
		self.append @updateBBSMenu
		@about = Gtk::MenuItem.new('About this program.')
		self.append @about

		self.show_all
	end

	def updateButton
		@updateBBSMenu
	end

	def about
		@about
	end
end

class UrlView < Gtk::Entry
	def initialize
		super()
		self.set_editable(true)
	end
end

class Ci
	include Profile
	include BBSMenu
	include CiUtil
	include NetUp

	def initialize(widget)
		@top = widget
		getBBSMenu if $cfg['bbsMenuCheck']
		@title = ''
		@dat = ''
		@bookmarkFilter = Status.new
		@tabLock = Status.new
		@threadChain = {}
		@tThr = Thread.fork { Thread.exit }
		@sThr = Thread.fork { Thread.exit }
	end

	def startCi
		# get session
		Thread.fork {
			@windmill.start('Session:0')
			if File.exist?("#{Root}session")
				fh = open("#{Root}session")
					session = fh.read
					fh.close
				session.each {|line|
					a = line.split(' ')
					board = a.shift
				dat = a.shift
					title = a.join(' ')
					textFrameThreadGet(board, dat, false)
					while true
						sleep 0.2
						break unless @windmill.q.include?('G:'.concat(dat))
					end
				}
			end
			@windmill.stop('Session:0')
		}

		@top.set_focus(@subjects.widget)	
	end

	def exitCi
		session = ''
		@mainNote.set_page(0)
		@mainNote.next_page
		while @mainNote.get_current_page != 0
			session << @mainNote.cur_page.child.getid['board']+' '
			session << @mainNote.cur_page.child.getid['dat']+' '
			session << @mainNote.cur_page.child.getid['title']+"\n"
			@mainNote.cur_page.child.setVadjInfo
			@threadChain.delete(@mainNote.cur_page.child.getid['dat'])
			@mainNote.remove_page(@mainNote.get_current_page)
			@mainNote.next_page
		end
		fh = open("#{Root}session", 'w')
		fh.write session
		fh.close
		profileWrite(@mainNote.cur_page.child.board)
	end

	def sizeAllocate
		n = @mainNote.get_current_page
		@mainNote.set_page(@threadChain.size)
		while @mainNote.get_current_page != 0
			@mainNote.cur_page.child.postClose unless @mainNote.cur_page.child.open?
			@mainNote.prev_page
		end
		@mainNote.set_page(n)
	end

	def subjectFrame
		@subjects = SubjectFrame.new(@top, profileRead)

		@subjects.widget.signal_connect('select_row') {|w, r, c, e|
			if e == nil
			elsif c == 0
				Thread.fork {
				sleep 3
				@topCancel.clicked
				}
			end
		}

		@subjects.widget.signal_connect('button_release_event') {|w, e|
			unless @subjects.pop?
				case e.button
				when 1
					r = 0
					@subjects.widget.each_selection {|row| r = row }
					if @windmill.q.include?('G:Subject') #=> downloadĤΥ
						textFrameThreadGet(@subjects.past, @subjects.hash[@subjects.widget.get_text(r, 0)], true, @bookmarkButton.active?)
					else #=> ̾
						textFrameThreadGet(@subjects.board, @subjects.hash[@subjects.widget.get_text(r, 0)], true, @bookmarkButton.active?)
					end

				end
			end
		}

		@subjects.widget.signal_connect('key_press_event') {|w, e|
			case e.keyval
			when Gdk::GDK_space  # Gdk::GDK_Return
				r = 0
				@subjects.widget.each_selection {|row| r = row }
				if @windmill.q.include?('G:Subject') #=> downloadĤΥ
					textFrameThreadGet(@subjects.past, @subjects.hash[@subjects.widget.get_text(r, 0)], true, @bookmarkButton.active?)
				else #=> ̾
					textFrameThreadGet(@subjects.board, @subjects.hash[@subjects.widget.get_text(r, 0)], true, @bookmarkButton.active?)
				end
			when Gdk::GDK_h
				@mainNote.prev_page
				switchNote(true)
			when Gdk::GDK_l
				@mainNote.next_page
				switchNote(true)
			when Gdk::GDK_L
				@bookmarkButton.clicked  # Update tabs Lock
			when Gdk::GDK_b
				@topBookmark.clicked
			when Gdk::GDK_r
				@topReload.clicked
			when Gdk::GDK_c
				@topCancel.clicked
			when Gdk::GDK_s
				@subjects.check
			when Gdk::GDK_S
				@topSelect.clicked
			when Gdk::GDK_f
				@subjects.update(false)
				@topBookmark.active = false
			when Gdk::GDK_slash
				goFind
			when Gdk::GDK_q
				@topExit.clicked
			end
		}
		return(@subjects)
	end

	def favoriteBBar
		$cfg['bookmarkButtons'] = 256 if $cfg['bookmarkButtons'] == 0
		box = Gtk::HBox.new
		boards = Gtk::HBox.new
			favorites = getFavorite
			if favorites != []
				$cfg['bookmarkButtons'] = favorites.size if $cfg['bookmarkButtons'] > favorites.size
				$cfg['bookmarkButtons'].times {|i|
					n, uri = favorites[i]
					b = ''
					b = Gtk::Button.new(n)
					b.signal_connect('clicked') {
						server, board = parseUri(uri)
						switchBoard(board)
					}
					box.pack_start b
				}
			end
		return(box)
	end

	def boardSelector
		@boardTree = BoardSelector.new
		@boardTree.widget.signal_connect('key_press_event') {|w, e|
			case e.keyval
			when Gdk::GDK_space
				node = ''
				@boardTree.widget.each_selection {|n| node = n }
				if @boardTree.widget.get_node_info(node)[6]
					server, board = parseUri(@boardTree.widget.node_get_row_data(node).uri)
					switchBoard(board, false)
					@top.set_focus(@boardTree.widget)
				else
					@boardTree.widget.toggle_expansion(node)
				end
			when Gdk::GDK_r
				@sThr = Thread.fork {
					w = @windmill.start('U:BoardMenu')
					if w
						@top.set_focus(@mainNote.cur_page.child.widget)
						@boardTree.update
						@windmill.stop('U:BoardMenu')
					end
				}
			when Gdk::GDK_S
				@topSelect.clicked
			when Gdk::GDK_q
				@topSelect.clicked
			end
		}
		@boardTree.widget.signal_connect('button_release_event') {|w, e|
			case e.button
			when 1
				node = ''
				@boardTree.widget.each_selection {|n| node = n }
				if @boardTree.widget.get_node_info(node)[6]
					server, board = parseUri(@boardTree.widget.node_get_row_data(node).uri)
					switchBoard(board) if board != @subjects.board
					@top.set_focus(@boardTree.widget)
				#else
				#	@boardTree.widget.toggle_expansion(node)
				end
			end
		}
		return(@boardTree)
	end

	def topButtons
		buttons = Gtk::HBox.new
		@topSelect = Gtk::ToggleButton.new.add Pix.getPixmap('boardselect')
			setTooltip(@topSelect, 'Board Selector Open/Close')
			@topSelect.signal_connect('clicked') {
				if @topSelect.active?
					@mainPane.set_position(BSActive) 
					@mainPane.set_gutter_size($cfg['boardSelectorBorderWidth']+2)
					@mainPane.set_handle_size($cfg['boardSelectorBorderWidth'])
					@top.set_focus(@boardTree.widget)
				else
					@mainPane.set_position(BSNonActive)
					@mainPane.set_gutter_size(0)
					@mainPane.set_handle_size(0)
					@top.set_focus(@mainNote.cur_page.child.widget)
				end
			}
		@topBookmark = Gtk::ToggleButton.new.add Pix.getPixmap('bookmark')
			setTooltip(@topBookmark, 'BookMark Open/Close')
			@topBookmark.signal_connect('clicked') {
				if @topBookmark.active?
					@subjects.update(false, false, true)
				else
					@subjects.update(false)
				end
			}
		@topReload = Gtk::Button.new.add Pix.getPixmap('refresh_blue')
			setTooltip(@topReload, 'Reload')
			@topReload.signal_connect('clicked') {
				c = @mainNote.cur_page.child
				case c.type
				when 'board'
					@sThr = Thread.fork {
						w = @windmill.start('U:Subject')
						if w
							c.update
							@top.set_focus(c.widget)
							@windmill.stop('U:Subject')
						end
					}
				when 'thread'
					@tThr = Thread.fork {
						w = @windmill.start('U:'.concat(c.getid['dat']))
						if w
							c.update
							@top.set_focus(c.widget)
							@windmill.stop('U:'.concat(c.getid['dat']))
						end
					}
				end
			}
		@topCancel = Gtk::Button.new.add Pix.getPixmap('cancel')
			setTooltip(@topCancel, 'Stop')
			@topCancel.signal_connect('clicked') {
				@sThr.kill if @sThr.alive?
				@subjects.rollback
				@tThr.kill if @tThr.alive?
				@windmill.kill
				#@subjects.widget.unselect_all
			}

		@topFind = Gtk::Button.new.add Pix.getPixmap('search')
			setTooltip(@topFind, 'Search')
			@topFind.signal_connect('clicked') {
				if @mainNote.get_current_page == 0
					@subjects.update(false, @urlview.get_text)
				else
					@mainNote.cur_page.child.find(@urlview.get_text)
				end
				switchNote(true) if @urlview.get_text == ''
			}
		@topExit = Gtk::Button.new.add Pix.getPixmap('exit')
			setTooltip(@topExit, 'Exit')
			@topExit.signal_connect('clicked') { exitCi ; Gtk::main_quit }
		@urlview = UrlView.new
		# @urlview.set_text('Where is My Silver Bullet ?')
		# @urlview.set_text(' How many files(0-15) ?')
		# @urlview.set_text(' MEMORY 640KB + 13312KB OK')
		@urlview.set_text(' Welcome to C.i. World !!')

		if $cfg['useMigemo']
			@urlview.signal_connect('changed') {
				#p @urlview.get_text
				if @urlview.get_text !~ /^h/
					@mainNote.cur_page.child.increment(@urlview.get_text) if @mainNote.get_current_page != 0
				end
			}
		end

		@urlview.signal_connect('activate') {
			u = @urlview.get_text
			case u
			when /^http:\/\/.*?\/test\/read\.cgi\/(.*?)\/(.*?)\/.*/
				textFrameThreadGet($1, $2+'.dat', true)
			when /^http:\/\/.*?\/(.*?)\//
				board = $1
				if $bbsHash.include?(board)
					switchBoard(board)
				end
			else
				@topFind.clicked
			end
		}
		if $cfg['netUpCi']
		 	result, body = netUp
		 	@urlview.set_text(body.chomp) if result
		end

		@windmill = Windmill.new
		@windmill.signal_connect('button_press_event') {|w, e|
			showConfig.popup(nil, nil, nil, e.button, e.time)
		}

		# Thread Buttons
		@bookmarkButton = Gtk::CheckButton.new
		#setTooltip(@bookmarkButton, 'Bookmark Add or Delete')
		setTooltip(@bookmarkButton, 'Focus to the select thread ?')
		@bookmarkButton.signal_connect('toggled') {|w|
			if @mainNote.get_current_page != 0
				unless @switch
					if @mainNote.cur_page.child.bookmark?
						@mainNote.cur_page.child.deleteBookmark
					else
						@mainNote.cur_page.child.addBookmark
					end
				end
			else
				@tabLock.toggleStatus
			end
		}

		@topFollowup = Gtk::Button.new.add Pix.getPixmap('edit')
		@topFollowup.set_sensitive(false)
		setTooltip(@topFollowup, 'Follow Up')

		@topFollowup.signal_connect('clicked') {
			if @mainNote.get_current_page != 0
				@mainNote.cur_page.child.postOpen
				@top.set_focus(@mainNote.cur_page.child.post.text)
			end
		}

		buttons.pack_start @topSelect, false
		buttons.pack_start @topBookmark, false
		buttons.pack_start @topReload, false
		buttons.pack_start @topCancel, false
		buttons.pack_start @topFollowup, false
		buttons.pack_start @topExit, false
		buttons.pack_start @bookmarkButton, false
		buttons.pack_start @urlview, true
		buttons.pack_start @topFind, false
		buttons.pack_start @windmill, false
		return(buttons)
	end

	def mainNote
		@mainNote = Gtk::Notebook.new
			@mainNote.set_scrollable(true)
			@mainNote.append_page(subjectFrame, Gtk::Label.new("#{@subjects.board.capitalize}@2ch"))

		@mainNote.signal_connect('button_release_event') {|w, e|
			switchNote(true) if e.button != 4 && e.button != 5
		}

		return(@mainNote)
	end

	def switchNote(focus = false)
		@switch = true
		cur = @mainNote.cur_page.child
			if @mainNote.get_current_page == 0
				setTooltip(@bookmarkButton, 'Focus to the select thread ?')
				if @bookmarkButton.active? != @tabLock.active?
					@bookmarkButton.active = @tabLock.active?
					@tabLock.toggleStatus  # signalǤtoggleƤΤ1󤳤toggleʤȹʤ
				end
				@top.set_title("C.i. - Compact Interface for 2ch. version #{CiVersion} (#{CiCode})")
				@urlview.set_text("http://#{$bbsHash[cur.board]}/#{cur.board}/")
				@mainNote.set_tab_label_text(cur, "#{cur.board.capitalize}@2ch")
				@topBookmark.set_sensitive(true)
				@topFollowup.set_sensitive(false)
				@top.set_focus(@subjects.widget) if focus
			elsif focus
				title = cur.getid['title']
				url = cur.getid['url']
				@urlview.set_text(url)
				if cur.bookmark?
					@bookmarkButton.active = true
				else
					@bookmarkButton.active = false
				end
				setTooltip(@bookmarkButton, 'Bookmark Add or Delete')
				@top.set_title("#{title} - C.i. (version: #{CiVersion})")
				@topBookmark.set_sensitive(false)
				@topFollowup.set_sensitive(true)
				@top.set_focus(@mainNote.cur_page.child.widget)
			end
		@switch = false
	end

	def mainPane
		@mainPane = Gtk::HPaned.new
		bs = boardSelector
		case $cfg['boardSelect']
		when 'right'
			@mainPane.pack1(mainNote, true, true)
			@mainPane.pack2(bs, false, true)
		else
			@mainPane.pack1(bs, false, true)
			@mainPane.pack2(mainNote, true, true)
		end
		@mainPane.set_gutter_size(2)
		@mainPane.set_handle_size(2)
		@mainPane.set_position(BSNonActive)
		return(@mainPane)
	end

	def switchBoard(board, focus = false)
		@sThr.kill if @sThr.alive?
		@subjects.rollback
		@windmill.stop('G:Subject')
		@windmill.stop('U:Subject')
		@subjects.switch(board)
		@sThr = Thread.fork {
			w = @windmill.start('G:Subject')
			if w
				@subjects.update(false)
				@windmill.stop('G:Subject')
				@mainNote.set_page(0)
				switchNote(focus)
				@urlview.set_text("http://#{$bbsHash[board]}/#{board}/")
				@mainNote.set_tab_label_text(@mainNote.cur_page.child,
					"#{board.capitalize}@2ch")
				@subjects.freeze
				@topBookmark.set_active(false)
				@subjects.thaw
			end
		}
	end

	def tabMove(widgets, direction)
		return if @mainNote.get_current_page == 1 and direction
		if direction == true  #=> prev
			p = @mainNote.get_current_page - 1
		else #=> next
			p = @mainNote.get_current_page + 1
		end
		@mainNote.reorder_child(widgets, p)
	end

	def textFrameThreadGet(board, dat, focus = true, focuscheck = false)
		focus = false if focuscheck  # ť¡ľĤꡣ
		@dat = dat
		w = @windmill.start('G:'.concat(dat))
		return(false) unless w 
		@tThr = Thread.fork {
			r = 0
			@subjects.widget.each_selection {|s| r = s }
			if @threadChain.include?(dat)
				@mainNote.set_page(0)
				@mainNote.next_page
				while @mainNote.cur_page.child.getid['dat'] != dat
					@mainNote.next_page
				end
				@mainNote.cur_page.child.update
				@subjects.cached(r) if @subjects.board == board
			else
				uri = "http://#{$bbsHash[board]}/test/read.cgi/#{board}/#{dat.sub(/\.dat/, '/')}"
				texts = TextFrame.new(board, dat, uri, @top)
				texts.widget.signal_connect('key_press_event') {|w, e|
					case e.keyval
					when Gdk::GDK_h
						@mainNote.prev_page
						switchNote(true)
					when Gdk::GDK_H
						tabMove(texts, true)
					when Gdk::GDK_l
						@mainNote.next_page
						switchNote(true)
					when Gdk::GDK_L
						tabMove(texts, false)
					when Gdk::GDK_slash
						goFind
					when Gdk::GDK_r
						@topReload.clicked
					when Gdk::GDK_R
						@tThr = Thread.fork {
							w = @windmill.start('U:'.concat(texts.getid['dat']))
							if w
								texts.reget
								@top.set_focus(texts.widget)
								@windmill.stop('U:'.concat(texts.getid['dat']))
							end
						}
					when Gdk::GDK_b
						@bookmarkButton.toggled
						switchNote(true)
					when Gdk::GDK_w
						@topFollowup.clicked
					when Gdk::GDK_q
						textFrameClose(texts)
						switchNote(true)
					end
				}
				texts.widget.signal_connect('button_press_event') {|w, e|
					case e.button
					when 2
						doRetry = false
						doRetry = true if texts.widget.get_chars(0, 100).gsub!(/\n.*/m, '') \
							== DownLoadFailed.gsub(/\n.*/m, '')
						if texts.has_selection?
							target = texts.getSelection
							if target =~ Regex2chThread and doRetry and target =~ RegexUri
								target = $2  # ֲƱʤ......
								target.gsub!(/^t+p/, 'http')
								system("#{$cfg['httpCommand'].sub(/%d/, target)}")
							elsif target =~ Regex2chThread
								b = $3 ; d = $4
								b.sub(/(.+?)\/(\d+)/) { b = $1 ; d = $2 } if b =~ /\//
								textFrameThreadGet(b, d.concat('.dat'))
							elsif target =~ RegexUri
								target = $2
								target.gsub!(/^t+p/, 'http')
								system("#{$cfg['httpCommand'].sub(/%d/, target)}")
							end
						end
					end
				}

				@threadChain[dat]= texts
				titleLabel = texts.label
				case $cfg['tabButtonType']
				when 0
				when 1
					texts.labelButton.signal_connect('clicked'){
						textFrameClose(texts)
						switchNote(true)
					}
				else
					texts.labelButton.signal_connect('clicked'){
						textFrameClose(texts)
						switchNote(true)
					}
					texts.labelButtonNext.signal_connect('clicked'){
						tabMove(texts, false)
					}
					texts.labelButtonPrev.signal_connect('clicked'){
						tabMove(texts, true)
					}
				end

				@mainNote.append_page(texts, titleLabel)
				texts.show_all
				texts.postClose
				texts.adjust

				if focus
					@mainNote.next_page
					while @mainNote.cur_page.child.getid['dat'] != dat
						@mainNote.next_page
					end
				end
				@subjects.cached(r) if @subjects.board == board
			end
			if focus
				@top.set_focus(@mainNote.cur_page.child.widget)
				switchNote(true)
			end
			#@subjects.widget.unselect_all
			@windmill.stop('G:'.concat(dat))
		}
	end

	def textFrameClose(widget)
		tmp = 0
		widget.setVadjInfo if widget.getid['title'] !~ /Download failed/
		@threadChain.delete(widget.getid['dat'])
		if @mainNote.cur_page.child == widget
			@mainNote.remove_page(@mainNote.get_current_page)
		else
			tmp = @mainNote.cur_page.child.getid['dat'] if @mainNote.get_current_page != 0
			@mainNote.set_page(0)
			@mainNote.next_page
			while @mainNote.cur_page.child.getid['dat'] != widget.getid['dat']
				@mainNote.next_page
			end
			@mainNote.remove_page(@mainNote.get_current_page)
			@mainNote.set_page(0)
			if tmp != 0
				@mainNote.next_page
				while @mainNote.cur_page.child.getid['dat'] != tmp
					@mainNote.next_page
				end
			end
		end
	end

	def goFind
		@urlview.set_text('')
		@top.set_focus(@urlview)
	end

	def showConfig
		config = ConfigPop.new
		config.updateButton.signal_connect('activate'){
			@sThr = Thread.fork {
				w = @windmill.start('U:BoardMenu')
				if w
					@top.set_focus(@mainNote.cur_page.child.widget)
					@boardTree.update
					@windmill.stop('U:BoardMenu')
				end
			}
		}
		config.about.signal_connect('activate'){ About.new.show_all }
		return(config)
	end
end

gtkrc = Root + 'gtkrc'
Gtk::RC.parse(gtkrc) if File.exist?(gtkrc)

w = Gtk::Window.new
w.set_default_size($cfg['defaultWidth'], $cfg['defaultHeight'])
w.set_title("C.i. - Compact Interface for 2ch. version #{CiVersion} (#{CiCode})")
# w.show_all
w.realize
Pix = CiPix.new(w)
ci = Ci.new(w)

# set main pane value
#

case $cfg['boardSelect']
when 'right'
	BSActive = $cfg['boardSelectorWidth']
	BSNonActive = 5000
else
	BSActive = $cfg['defaultWidth'] - $cfg['boardSelectorWidth']
	BSNonActive = 0
end

main = Gtk::VBox.new
main.pack_start ci.topButtons, false
main.pack_start ci.mainPane
main.pack_start ci.favoriteBBar, false

w.signal_connect('delete_event') { ci.exitCi ; Gtk::main_quit }
=begin
w.signal_connect('key_press_event') {|w, e|
	if e.state == Gdk::CONTROL_MASK
		case e.keyval
		when Gdk::GDK_q
			ci.exitCi ; Gtk::main_quit
		#when Gdk::GDK_a
		#	About.new.show_all
		end
	end
}
=end
w.add main
w.show_all
w.signal_connect('size_allocate') {
	p 'allocate '
	ci.sizeAllocate
}
ci.startCi
Gtk.main
